#include "cg_local.h"


// autofire stuff
/////////////////

vmCvar_t af_enabled;
vmCvar_t af_length;

// autoaim stuff
////////////////
vmCvar_t aa_enabled;
vmCvar_t aa_lockvisible;
vmCvar_t aa_lockmethod;

vmCvar_t aa_lag;
vmCvar_t aa_box;
vmCvar_t aa_adjustpitch;

// auto adjustment of yaw/pitch speeds
vmCvar_t aa_autoadjust;
vmCvar_t aa_lockdegrees;
vmCvar_t aa_pitchscale;
vmCvar_t aa_yawscale;

vmCvar_t aa_targets;


void AF_Fire(void) {

	if(af_enabled.integer != 0) {
		// fire
		trap_SendConsoleCommand("+attack\n");
	        trap_SendConsoleCommand("-attack\n");
	}
}

// lockmethod 0 will lock target based on whom is closest to the crosshair.
// find target via lockmethod 0 and return it.  -1 if no target.
int AA_LockMethod_0(int old_target) {

	// found target
	int target = -1;

	// vector from us to target
	vec3_t tvector;

	// player viewangles
	vec3_t pviewangles;

	// ideal viewangle we would want to obtain
	vec3_t iviewangles;

	// player origin and target origin
	vec3_t porigin, torigin;

	int i;
	float length, minangles = -1;
	
	// player team
	int pteam;
	
	// hold target entity
	centity_t *cent;

	// trace to see if target is visable.
	trace_t	trace;

	pteam = cgs.clientinfo[cg.snap->ps.clientNum].team;	


	// copy player origin into porigin,
	VectorCopy(cg.refdef.vieworg,porigin);

	// copy player viewangles
	VectorCopy(cg.refdefViewAngles,&pviewangles)

/*	if(old_target != -1) {
		cent = &cg_entities[old_target];
		// return cause we dont want to change the target if we already have one.
		if(!(cent->currentState.eFlags & EF_DEAD)) {
			return old_target;
		}
	}
*/	// traverse all clients
	for(i = 0;i < MAX_CLIENTS ;i++) {
		// dont lock onto ourself
		if(i != cg.snap->ps.clientNum) {

			// only target clients which we want. all/otherteam/sameteam
			if(aa_targets.integer == TAR_EVERYONE || (aa_targets.integer == TAR_OTHERTEAM && pteam != cgs.clientinfo[i].team) ||
			(aa_targets.integer == TAR_SAMETEAM && pteam == cgs.clientinfo[i].team)) {
				cent = &cg_entities[i];
				
				// make sure entity is player,not dead, and being drawn 
				if(cent->currentState.eType == ET_PLAYER && !(cent->currentState.eFlags & EF_DEAD) && !(cent->currentState.eFlags & EF_NODRAW)) {
					// copy possible targets origin
					VectorCopy(cent->lerpOrigin,torigin);
					
					// check if target is visiable to us.
					if(aa_lockvisible.integer != 0 ) {
						CG_Trace(&trace,porigin,NULL,NULL,torigin,cg.snap->ps.clientNum,CONTENTS_SOLID|CONTENTS_BODY);
					}

					// if they are visable or we dont care continue to check this client as a possible target
					if(aa_lockvisible.integer == 0 || trace.entityNum == i) {
						// generate the vector from us to the target and its length
						VectorSubtract(torigin,porigin,tvector);
							
						// bust out some geomotry to get the viewangle
						// generate the idealview angles we want
						length = sqrt(tvector[0]*tvector[0] + tvector[1]*tvector[1]);
						iviewangles[PITCH] = atan2(length,tvector[2])*180.0f/M_PI - 90;
						iviewangles[YAW] = atan2(tvector[1],tvector[0])*180.0f/M_PI;

						// do some calculations to abtain the difference in angles from our
						// current view to that of the ideal angles.
						iviewangles[PITCH] = Q_fabs(iviewangles[PITCH] - pviewangles[PITCH]);
						iviewangles[YAW] = Q_fabs(iviewangles[YAW] - pviewangles[YAW]);
						if(iviewangles[PITCH] > 180) {
							iviewangles[PITCH] -= 180;
						}
						if(iviewangles[YAW] > 180) {
							iviewangles[YAW] -= 180;
						}
			
						if(minangles > iviewangles[YAW] + iviewangles[PITCH] || minangles == -1) {
							target = i;
							minangles = iviewangles[YAW] + iviewangles[PITCH];
						}
					}
				}
			}
		}
	}
	return target;
}
// lockmethod 1 will lock target based on whom is closest to us distance wise.
// find target via lockmethod 1 and return it.  -1 if no target.
int AA_LockMethod_1(int old_target) {

	// found target
	int target = -1;

	// vector from us to target
	vec3_t tvector;

	// player origin and target origin
	vec3_t porigin, torigin;

	int i;
	float length, minlength = -1;
	
	// player team
	int pteam;
	
	// hold target entity
	centity_t *cent;

	// trace to see if target is visable.
	trace_t	trace;

	pteam = cgs.clientinfo[cg.snap->ps.clientNum].team;	


	// copy player origin into porigin,
	VectorCopy(cg.refdef.vieworg,porigin);
	
	// traverse all clients
	for(i = 0;i < MAX_CLIENTS ;i++) {
		// dont lock onto ourself
		if(i != cg.snap->ps.clientNum) {

			// only target clients which we want. all/otherteam/sameteam
			if(aa_targets.integer == TAR_EVERYONE || (aa_targets.integer == TAR_OTHERTEAM && pteam != cgs.clientinfo[i].team) ||
			(aa_targets.integer == TAR_SAMETEAM && pteam == cgs.clientinfo[i].team)) {
				cent = &cg_entities[i];
				
				// make sure entity is player,not dead, and being drawn 
				if(cent->currentState.eType == ET_PLAYER && !(cent->currentState.eFlags & EF_DEAD) && !(cent->currentState.eFlags & EF_NODRAW)) {
					// copy possible targets origin
					VectorCopy(cent->lerpOrigin,torigin);
					
					// check if target is visiable to us.
					if(aa_lockvisible.integer != 0 ) {
						CG_Trace(&trace,porigin,NULL,NULL,torigin,cg.snap->ps.clientNum,CONTENTS_SOLID|CONTENTS_BODY);
					}

					// if they are visable or we dont care continue to check this client as a possible target
					if(aa_lockvisible.integer == 0 || trace.entityNum == i) {
						// generate the vector from us to the target and its length
						VectorSubtract(torigin,porigin,tvector);
							
						// get the length of the vector from us to possible target
						length = VectorLength(tvector);
						
						if(length < minlength || minlength == -1) {
							minlength = length;
							target = i;
						}
					}
				}
			}
		}
	}
	return target;
}


// given target client number, calculate ideal viewangles.
void AA_CalculateAngles(int target, vec3_t iviewangles) {

	// hold onto old target number and origin
	// used for calculating velocity.
	static int old_target;
	static vec3_t old_torigin;


	// vector from us to target
	vec3_t tvector;

	// player origin and target origin
	vec3_t porigin, torigin;

	// rough velocity vector of target;l
	vec3_t tvelocity;

	float length,yaw,pitch;
	// hold target entity
	centity_t *cent;

	if(target == -1) {
		old_target = -1;
	}

	cent = &cg_entities[target];

	// copy origins
	VectorCopy(cg.refdef.vieworg,porigin);
	VectorCopy(cent->lerpOrigin,torigin);

	// we have new target so we want the velocity to be 0 because we dont know what it is.
	if(target != old_target) {
		VectorCopy(torigin,old_torigin);
	}

	// calculate rough velocity vector of target
	VectorSubtract(torigin,old_torigin,tvelocity);

	// back up target number and origin for next time we are called.
	old_target = target;
	VectorCopy(torigin,old_torigin);
	
	// now try and create the best tvector allowing for lag adjustment, etc.
	tvector[0] = torigin[0] - porigin[0] + (aa_lag.value * tvelocity[0]);
	tvector[1] = torigin[1] - porigin[1] + (aa_lag.value * tvelocity[1]);
	tvector[2] = torigin[2] - porigin[2] + aa_adjustpitch.integer + (aa_lag.value * tvelocity[2]); 

	// bust out some geomotry to get the viewangle
	// generate the ideal view angles we want
	length = sqrt(tvector[0]*tvector[0] + tvector[1]*tvector[1]);
	iviewangles[PITCH] = atan2(length,tvector[2])*180.0f/M_PI - 90;
	iviewangles[YAW] = atan2(tvector[1],tvector[0])*180.0f/M_PI;

	// make YAW be between 0-360 to make things easier.
	iviewangles[YAW] += 180;



}		

// this will autoadjust our cl_yaw/pitchspeeds depending on how close our ideal viewangle is to our
// current viewangle.  if target is ourside the lockangles then it will set the speeds to 0 thus
// having the effect of not tracking them.
void AA_AutoAdjust(vec3_t iviewangles) {

	// our current view angles;
	vec3_t pviewangles;

	float delta;
	
	// hold speeds var
	char speeds[32];

	VectorCopy(cg.refdefViewAngles,&pviewangles);
	pviewangles[YAW] += 180;

	// auto adjust stuff for pitch/yaw speeds.  this should help us "whip" to the target
	// and then slow down the pitch/yaw speed so we dont get a bobbing effect from going
	// past the ideal viewangle.
	if(aa_autoadjust.integer >= 0) {
		delta = Q_fabs(iviewangles[PITCH] - pviewangles[PITCH]);
		if(aa_lockdegrees.integer > delta) {
			Com_sprintf(speeds,sizeof(speeds),"cl_pitchspeed %d\n",(int)(delta * aa_pitchscale.value));
        	        trap_SendConsoleCommand(speeds);
		} else {
			// we want to stop tracking in both directions
                        trap_SendConsoleCommand("cl_yawspeed 0\n");
                        trap_SendConsoleCommand("cl_pitchspeed 0\n");
			return;
                }

		delta = Q_fabs(iviewangles[YAW] - pviewangles[YAW]);
		if(delta > 180) delta -= 180;
	
		if(aa_lockdegrees.integer > delta) {
			Com_sprintf(speeds,sizeof(speeds),"cl_yawspeed %d\n",(int)(delta * aa_yawscale.value));
        	        trap_SendConsoleCommand(speeds);
		} else {
			// same as about stop tracking in both directions
			trap_SendConsoleCommand("cl_yawspeed 0\n");
			trap_SendConsoleCommand("cl_pitchspeed 0\n");
			return;
		}
	}


}

// return true if target is in our crosshair
qboolean AA_TargetInCrosshair(int target) {
	
	// point in space where we want to trace to
	vec3_t end;

	// temp trace 
	trace_t trace;

	// create vector from our viewangle and trace out from it
	VectorMA(cg.refdef.vieworg,8192,cg.refdef.viewaxis[0], end );

	// preform trace
	CG_Trace(&trace,cg.refdef.vieworg,NULL,NULL,end,cg.snap->ps.clientNum,CONTENTS_SOLID|CONTENTS_BODY);

	// found our target, or we dont care which target it is.
	if(trace.entityNum == target || (target == -1 && trace.entityNum <= MAX_CLIENTS)) {
		return qtrue;
	}

	return qfalse;
}

// return true if target is visible
qboolean AA_TargetVisible(int target) {
	
	// temp trace 
	trace_t trace;

	// target entity
	centity_t *cent;
	
	cent = &cg_entities[target];

	// preform trace
	CG_Trace(&trace,cg.refdef.vieworg,NULL,NULL,cent->lerpOrigin,cg.snap->ps.clientNum,CONTENTS_SOLID|CONTENTS_BODY);

	// found our target, or we dont care which target it is.
	if(trace.entityNum == target) {
		return qtrue;
	}

	return qfalse;
}



// return the distance from us to target
float AA_TargetDistance(int target) {
	
	// vector from us to target
	vec3_t tvector;

	// target entity
	centity_t *cent;
	
	if(target < 0) {
		return af_length.integer + 1;
	}

	cent = &cg_entities[target];

	VectorSubtract(cent->lerpOrigin,cg.refdef.vieworg,tvector);

	return(VectorLength(tvector));
}

// take the given ideal viewangles and make the client goto them
// return 0 if we arent on target
// return 1 if we are
qboolean AA_ChangeView(int target, vec3_t iviewangles) {
	
	// let us know if both the pitch and yaw angles are ontarget.
	qboolean yaw_on, pitch_on;

	qboolean lk_right, lk_left, lk_up, lk_down;

	static int old_target;

	float delta;
	static vec3_t lk_status;

	float box;
	// our current view angles;
	vec3_t pviewangles;

	VectorCopy(cg.refdefViewAngles,&pviewangles);
	// make calculations easier
	pviewangles[YAW] += 180;

	box = aa_box.value * 100.0 / AA_TargetDistance(target);
	// stuff we need to set to false
	yaw_on = pitch_on = lk_up = lk_down = lk_right = lk_left = qfalse;
	
	
	// new target, make sure everything is clear.
	if(old_target != target) {
		lk_status[YAW] = LK_NONE;
		lk_status[PITCH] = LK_NONE;
                trap_SendConsoleCommand("-lookup\n");
                trap_SendConsoleCommand("-lookdown\n");
		trap_SendConsoleCommand("-left\n"); 
                trap_SendConsoleCommand("-right\n"); 
		old_target = target;
	}
		
	// adjust pitch
	delta = iviewangles[PITCH] - pviewangles[PITCH];

	if(delta < - box) {
		lk_up = qtrue;
		if(lk_status[PITCH] != LK_UP) {
			lk_status[PITCH] = LK_UP;
			trap_SendConsoleCommand("-lookdown\n");
                	trap_SendConsoleCommand("+lookup\n");
		}
 	}

	if(delta > box) {
		lk_down = qtrue;
		if(lk_status[PITCH] != LK_DOWN) {
			lk_status[PITCH] = LK_DOWN;
			trap_SendConsoleCommand("-lookup\n");  
        	        trap_SendConsoleCommand("+lookdown\n");
		}
	}

	if(!lk_down && !lk_up && lk_status[PITCH] != LK_NONE) {
		lk_status[PITCH] = LK_NONE;
                trap_SendConsoleCommand("-lookup\n");
                trap_SendConsoleCommand("-lookdown\n");
	}

	// adjust yaw
	delta = iviewangles[YAW] - pviewangles[YAW];

	// find minimum angle;
	if(delta > 180) delta -= 360;
	if(delta < -180) delta += 360;
 
	// if delta is negative target is to the left of us
	// if delta is positive target is to the right of us.

	if(delta > box) {
		lk_left = qtrue;
		if(lk_status[YAW] != LK_LEFT) {
			lk_status[YAW] = LK_LEFT;
			trap_SendConsoleCommand("-right\n");
                	trap_SendConsoleCommand("+left\n");
		}
	}

	if(delta < - box) {
		lk_right = qtrue;
		if(lk_status[YAW] != LK_RIGHT) {
			lk_status[YAW] = LK_RIGHT;
			trap_SendConsoleCommand("-left\n"); 
        	        trap_SendConsoleCommand("+right\n");
		}
	}

	if(!lk_right && !lk_left && lk_status[YAW] != LK_NONE) {
		lk_status[YAW] = LK_NONE;
		trap_SendConsoleCommand("-left\n"); 
                trap_SendConsoleCommand("-right\n"); 
	}
	
	// return true if we are on target with our ideal angles and target is visible
	if(lk_status[YAW] == LK_NONE && lk_status[PITCH] == LK_NONE && AA_TargetVisible(target)) {
		return qtrue;

	}

	// also return true of we are very close to target and they are within our real crosshair
	if(af_length.integer > AA_TargetDistance(target) && AA_TargetInCrosshair(target)) {
		return qtrue;
	}

	return qfalse;
}
		

void CG_GotWalls(void) {

	static int old_target;
	static qboolean motion_cleared;
	int target = -1;
	vec3_t iviewangles;

	// do autoaim stuff if enabled
	if(aa_enabled.integer != 0) {
		// get target based on lockmethod
		switch(aa_lockmethod.integer) {
			case LM_CROSSHAIR:
				target = AA_LockMethod_0(old_target);
				old_target = target;
				break;
			case LM_DISTANCE:
				target = AA_LockMethod_1(old_target);		
				old_target = target;
				break;
		}
		
		// have target, now try and track him
		if(target != -1) {

			// get ideal angles and change pitch/yaw speeds
			AA_CalculateAngles(target,iviewangles);
			AA_AutoAdjust(iviewangles);

			// change angles
			if(AA_ChangeView(target,iviewangles)) {
				// fire if need be
				if(af_enabled.integer != 0) {
					AF_Fire();
				}
			}
			motion_cleared = qfalse;
		} else {
			AA_CalculateAngles(-1,iviewangles);
			if(!motion_cleared) {
                        	trap_SendConsoleCommand("-left\n");
                        	trap_SendConsoleCommand("-right\n");
                        	trap_SendConsoleCommand("-lookup\n");
                        	trap_SendConsoleCommand("-lookdown\n");
				motion_cleared = qtrue;
			}
		}	
	} else {
		if(!motion_cleared) {
			AA_CalculateAngles(-1,iviewangles);

			trap_SendConsoleCommand("-left\n");
                	trap_SendConsoleCommand("-right\n");
                	trap_SendConsoleCommand("-lookup\n");
                	trap_SendConsoleCommand("-lookdown\n");
			old_target = -1;
			motion_cleared = qtrue;
		}
		// autoaim off, autofire on
		if(af_enabled.integer != 0) {
			if(AA_TargetInCrosshair(-1)) {
				AF_Fire();
			}
		}
	}

}


// alias stuff

// +aa
void AA_Down(void) {
	trap_Cvar_Set("aa_enabled", "1");
	
}

// -aa
void AA_Up(void) {
	trap_Cvar_Set("aa_enabled", "0");
}

// +af 
void AF_Down(void) {
	trap_Cvar_Set("af_enabled", "1");
}

// -af
void AF_Up(void) {
	trap_Cvar_Set("af_enabled", "0");
}

// +aaf   
void AAF_Down(void) {
	trap_Cvar_Set("aa_enabled", "1");
	trap_Cvar_Set("af_enabled", "1");
}

// -aaf
void AAF_Up(void) {
	trap_Cvar_Set("aa_enabled", "0");
	trap_Cvar_Set("af_enabled", "0");
}

